#######################################################
# PROGRAM: AngristLavy_Table2
# PURPOSE: Recreates Table 2 of Angrist and Lavy (1999)
#######################################################
library(foreign)

# 5wNf[^ǂݍ
df.5 <- read.dta("final5.dta")

# f[^
df.5$avgmath <- ifelse(df.5$avgmath>100, df.5$avgmath-100, df.5$avgmath) 
df.5$avgverb <- ifelse(df.5$avgverb>100, df.5$avgverb-100, df.5$avgverb) 

df.5$avgverb[df.5$verbsize==0]  <- NA
df.5$passverb[df.5$verbsize==0] <- NA
df.5$avgmath[df.5$mathsize==0]  <- NA
df.5$passmath[df.5$mathsize==0] <- NA

df.5.2 <- df.5[1 < df.5$classize & df.5$classize < 45 & df.5$c_size >5,]
df.5.2 <- df.5.2[df.5.2$c_leom ==1 & df.5.2$c_pik <3,]


summary(df.5.2$avgverb)
summary(df.5.2$avgmath)
sd(df.5.2$avgverb, na.rm = TRUE)
sd(df.5.2$avgmath, na.rm = TRUE)

#KvpbP[WCXg[
install.packages("ivpack")
library(ivpack)
#COL 1
summary(lm.df.5.2.C1 <- lm(avgverb ~ classize, data = df.5.2))
#clustering-robust SE
res.se.C1 <- cluster.robust.se(lm.df.5.2.C1, clusterid = df.5.2$schlcode[!is.na(df.5.2[,"avgverb"])])
res.se.C1

#COL 2
summary(lm.df.5.2.C2 <- lm(avgverb ~ classize + tipuach, data = df.5.2))
#clustering-robust SE
res.se.C2 <- cluster.robust.se(lm.df.5.2.C2, clusterid = df.5.2$schlcode[!is.na(df.5.2[,"avgverb"])])
res.se.C2

#COL 3
summary(lm.df.5.2.C3 <- lm(avgverb ~ classize + tipuach + c_size, data = df.5.2))
#clustering-robust SE
res.se.C3 <- cluster.robust.se(lm.df.5.2.C3, clusterid = df.5.2$schlcode[!is.na(df.5.2[,"avgverb"])])
res.se.C3

#COL 4
summary(lm.df.5.2.C4 <- lm(avgmath ~ classize, data = df.5.2))
#clustering-robust SE
res.se.C4 <- cluster.robust.se(lm.df.5.2.C4, clusterid = df.5.2$schlcode[!is.na(df.5.2[,"avgmath"])])
res.se.C4

#COL 5
summary(lm.df.5.2.C5 <- lm(avgmath ~ classize + tipuach, data = df.5.2))
#clustering-robust SE
res.se.C5 <- cluster.robust.se(lm.df.5.2.C5, clusterid = df.5.2$schlcode[!is.na(df.5.2[,"avgmath"])])
res.se.C5

#COL 6
summary(lm.df.5.2.C6 <- lm(avgmath ~ classize + tipuach + c_size, data = df.5.2))
#clustering-robust SE
res.se.C6 <- cluster.robust.se(lm.df.5.2.C6, clusterid = df.5.2$schlcode[!is.na(df.5.2[,"avgmath"])])
res.se.C6


#4wNf[^ǂݍ
df.4 <- read.dta("final4.dta")

# f[^
df.4$avgmath <- ifelse(df.4$avgmath>100, df.4$avgmath-100, df.4$avgmath) 
df.4$avgverb <- ifelse(df.4$avgverb>100, df.4$avgverb-100, df.4$avgverb) 

df.4$avgverb[df.4$verbsize==0]  <- NA
df.4$passverb[df.4$verbsize==0] <- NA
df.4$avgmath[df.4$mathsize==0]  <- NA
df.4$passmath[df.4$mathsize==0] <- NA

df.4.2 <- df.4[1 < df.4$classize & df.4$classize < 45 & df.4$c_size >5,]
df.4.2 <- df.4.2[df.4.2$c_leom ==1 & df.4.2$c_pik <3,]

summary(df.4.2$avgverb)
summary(df.4.2$avgmath)
sd(df.4.2$avgverb, na.rm = TRUE)
sd(df.4.2$avgmath, na.rm = TRUE)

#COL 7
summary(lm.df.4.2.C7 <- lm(avgverb ~ classize, data = df.4.2))
#clustering-robust SE
res.se.C7 <- cluster.robust.se(lm.df.4.2.C7, clusterid = df.4.2$schlcode[!is.na(df.4.2[,"avgverb"])])
res.se.C7

#COL 8
summary(lm.df.4.2.C8 <- lm(avgverb ~ classize + tipuach, data = df.4.2))
#clustering-robust SE
res.se.C8 <- cluster.robust.se(lm.df.4.2.C8, clusterid = df.4.2$schlcode[!is.na(df.4.2[,"avgverb"])])
res.se.C8

#COL 9
summary(lm.df.4.2.C9 <- lm(avgverb ~ classize + tipuach + c_size, data = df.4.2))
#clustering-robust SE
res.se.C9 <- cluster.robust.se(lm.df.4.2.C9, clusterid = df.4.2$schlcode[!is.na(df.4.2[,"avgverb"])])
res.se.C9

#COL 10
summary(lm.df.4.2.C10 <- lm(avgmath ~ classize, data = df.4.2))
#clustering-robust SE
res.se.C10 <- cluster.robust.se(lm.df.4.2.C10, clusterid = df.4.2$schlcode[!is.na(df.4.2[,"avgmath"])])
res.se.C10

#COL 11
summary(lm.df.4.2.C11 <- lm(avgmath ~ classize + tipuach, data = df.4.2))
#clustering-robust SE
res.se.C11 <- cluster.robust.se(lm.df.4.2.C11, clusterid = df.4.2$schlcode[!is.na(df.4.2[,"avgmath"])])
res.se.C11

#COL 12
summary(lm.df.4.2.C12 <- lm(avgmath ~ classize + tipuach + c_size, data = df.4.2))
#clustering-robust SE
res.se.C12 <- cluster.robust.se(lm.df.4.2.C12, clusterid = df.4.2$schlcode[!is.na(df.4.2[,"avgmath"])])
res.se.C12
