##########################
##第9章　実証分析問題9-B##
##########################

#パネル・データ分析用パッケージインストール
install.packages("plm")
#パネル・データ分析用パッケージ読み込み
require(plm)

#例9.2の再現
#データの読み込み
life9 <- read.table("9_2_life_xt.csv", header = TRUE, sep = ",")

#t=2期目（2009年）のデータを使って最小2乗法で回帰
reg1 <- lm(life ~ shock + income, data = subset(life9, t==2))
summary(reg1)

#plmパッケージを用いて，1階差分法（fd）による回帰
preg1 <- plm(life ~ shock_y2 + income, data = life9, effect ="individual", 
             model = "fd", index = c("id", "t"))
summary(preg1)

#例9.3の再現
#固定効果モデル（within）を用いた回帰
preg2 <- plm(life ~ shock + y2 + shock_y2 + income, data = life9, effect ="individual", 
             model = "within", index = c("id", "t"))
summary(preg2)
#n人分の切片平均値出力
mean(fixef(preg2))

#例9.4の再現
#変量効果モデル（random）を用いた回帰
preg3 <- plm(life ~ shock + y2 + shock_y2 + income, data = life9, effect ="individual", 
             model = "random", index = c("id", "t"))
summary(preg3)