###################################
## 第7章　重回帰分析の応用 例7.3 ##
###################################

#データの読み込み
income7 <- read.table("7_1_income.csv", header = TRUE, sep = ",")

#男性のみのデータを使って単回帰で推定
reg1 <- lm(lincome ~ yeduc, data = subset(income7, female == 0))
summary(reg1)
#残差2乗和を計算
SSR1 <- deviance(reg1)

#女性のみのデータを使って単回帰で推定
reg2 <- lm(lincome ~ yeduc, data = subset(income7, female == 1))
summary(reg2)
#残差2乗和を計算
SSR2 <- deviance(reg2)

#すべてのデータを使って単回帰で推定
reg3 <- lm(lincome ~ yeduc, data = income7)
summary(reg3)
#残差2乗和を計算
SSR <- deviance(reg3)

k <- reg3$rank
#チョウ検定統計量の計算
Fstat <- (SSR-(SSR1 + SSR2))/(SSR1 + SSR2) * (nrow(income7) - 2*k)/k
Fstat
#F統計量よりp値
1-pf(Fstat, k, (nrow(income7) - 2*k))

#または以下の関数により検定できる
reg4 <- lm(lincome ~ yeduc + female + female_yeduc, data = income7)
anova(reg3, reg4)

