#####################################
## 第9章　パネル・データ分析 例9.2 ##
#####################################

#データの読み込み
life9 <- read.table("9_2_life_xt.csv", header = TRUE, sep = ",")

#t=2期目（2009年）のデータを使って最小2乗法で回帰
reg1 <- lm(life ~ shock + income, data = subset(life9, t==2))
summary(reg1)

#パネル・データ分析用パッケージインストール
install.packages("plm")
#パネル・データ分析用パッケージ読み込み
require(plm)

#plmパッケージを用いて，1階差分法（fd）による回帰
preg1 <- plm(life ~ shock_y2 + income, data = life9, effect ="individual", 
             model = "fd", index = c("id", "t"))
summary(preg1)

#データセットで調整のうえで，最小2乗法で回帰する形で1階差分法の実行
#t=1のデータを抽出
life9_s1 <- subset(life9, t == 1)
#t=2のデータを抽出
life9_s2 <- subset(life9, t == 2)
#t=2とt=1の差分を取る
life9_ds <- life9_s2 - life9_s1
#差分を取ったデータを使って最小2乗法で回帰
reg2 <- lm(life ~ shock_y2 + income , data = life9_ds)
summary(reg2)
